// code by christelle

// BEGIN: globals
matrix<float> cPos(3,3,"eye");          // homogeneous transformation from local to world
matrix<float> cInv;                     // homogeneous transformation from world to local
matrix<float> cTarget(3,3,"eye");

#define       cRESOL            3       // for localization
#define       cPARAM            1760    // 4*11*5*8
float         cResol[cRESOL]={2.81f,0.75f,0.20f};
float         cParam[cPARAM];

#define       cDENSITY 409600
#define       cDENSITY_JOIN     0.08f
#define       cDENSITY_RANGEMIN 0.90f
#define       cDENSITY_RANGEMAX 5.50f
int           cDensity[cDENSITY];       // density function: high in regions close to obstacles, 0 for unexplored terrain
SDL_Surface*  cDensityStub;             // holds perceived data for updating density
SDL_Surface*  cDensityDraw;             // visualization of density function (just amplifies the values)

#define       cROUTE            500
#define       cROUTEHOME        800    
#define       cROUTEVALID       0.05f   // old routing is valid if robot did not more more than ...
float         cRouteDist[cDENSITY];     // reserve space for routing
int           cRoutePred[cDENSITY];     // reserve space for routing
int           cRouteMask[cDENSITY];     // reserve space for routing
SDL_Surface*  cRouteDraw;               // visualization of density function (just amplifies the values)

#define       cSTONE_MATCH      0.20f   // radius to identify perceived stone with stone in wmap
SDL_Surface*  cProfileDraw;             // for pictures of floor 
SDL_Surface*  cProfileGone;             
linked<int>   cPlan;
matrix<float> cCompass(3,1);            // in world coordinates
float         cPlanDist=0;

SDL_Surface*  cMap;                     // current view with respect to world

matrix<float> cDock(3,3,"eye");         // hole in the wall, vector along wall and vector inside
matrix<float> cDrop(3,3,"eye");         // point to drop stones
matrix<float> cTurn(3,3,"eye");         // point to turn
matrix<float> cStone(3,1024);           // use cStone.size[1] to get numberof stones in MAP
#define       cDISPLAY          4
int           cDisplay=2;
// END: globals


#include "cslam.cpp"


void cInit() {
  int c1,c2,c3,cnt=0;
  SDL_Surface* mySDL_Surface;
  mySDL_Surface=SDL_LoadBMP("res/cmap.bmp");                                          // 640x640    
    cDensityStub=SDL_ConvertSurface(mySDL_Surface,&jSDL_PixelFormat,SDL_SWSURFACE);   // for stupid drawing
    cDensityDraw=SDL_ConvertSurface(mySDL_Surface,&jSDL_PixelFormat,SDL_SWSURFACE);          
    cRouteDraw  =SDL_ConvertSurface(mySDL_Surface,&jSDL_PixelFormat,SDL_SWSURFACE);   // for stupid drawing  
    cProfileDraw=SDL_ConvertSurface(mySDL_Surface,&jSDL_PixelFormat,SDL_SWSURFACE);   // for stupid drawing      
    cProfileGone=SDL_ConvertSurface(mySDL_Surface,&jSDL_PixelFormat,SDL_SWSURFACE);   // for stupid drawing      
    cMap        =SDL_ConvertSurface(mySDL_Surface,&jSDL_PixelFormat,SDL_SWSURFACE);    
  SDL_FreeSurface(mySDL_Surface);
  cReset();
  for (c1=-5;c1<=5;c1++)                // turning
  for (c2=-2;c2<=2;c2++)                // max slide sidewards
  for (c3=-2;c3<=5;c3++) {              // max front & back  
    cParam[cnt++]=c1*0.0174532f;        // this is 1 degree    
    cParam[cnt++]=c2*0.01f;
    cParam[cnt++]=c3*0.01f;
    cParam[cnt++]=-sqrt((float)(c1*c1+c2*c2+c3*c3))*jEPS;
  }
  jTic[jTOC_LAST_SLAM]=jCLOCK_FUNC;
  c1=3;
}

void cProcess(SDL_Event &mySDL_Event) {  
  int c1;
  if (mySDL_Event.type==SDL_KEYDOWN) {
    switch (mySDL_Event.key.keysym.sym) {
      case SDLK_n:
        cReset();
        break;
      case SDLK_m:
        cDisplay++; cDisplay%=cDISPLAY;
        break;
      case SDLK_k:
        cBestQuality();
        break;
    }
  }
  if (mySDL_Event.type==SDL_MOUSEBUTTONDOWN) {
    bool pln=false;
    int pix=mySDL_Event.button.x;
    int piy=mySDL_Event.button.y;
    matrix<float> tmp(3,1);
    matrix<float> wld;
    if (jHUD_CAMERAL_X<pix&&pix<jHUD_CAMERAL_X+320&&jHUD_CAMERAL_Y<piy&&piy<jHUD_CAMERAL_Y+240) {
      tmp=jCam2gnd(0,pix-jHUD_CAMERAL_X+(piy-jHUD_CAMERAL_Y)*320);
      wld=cPos*tmp;
      cTarget.data[6]=wld.data[0];
      cTarget.data[7]=wld.data[1];
      pln=true;
    }
    if (jHUD_CAMERAR_X<pix&&pix<jHUD_CAMERAR_X+320&&jHUD_CAMERAR_Y<piy&&piy<jHUD_CAMERAR_Y+240) {
      tmp=jCam2gnd(1,pix-jHUD_CAMERAR_X+(piy-jHUD_CAMERAR_Y)*320);
      wld=cPos*tmp;
      cTarget.data[6]=wld.data[0];
      cTarget.data[7]=wld.data[1];
      pln=true;
    }
    if (jHUD_FRONT_X<pix&&pix<jHUD_FRONT_X+480&&jHUD_FRONT_Y<piy&&piy<jHUD_FRONT_Y+640) {
      tmp.data[0]=(piy-jHUD_FRONT_Y-jFRONT_Y)/100.0f;
      tmp.data[1]=(pix-jFRONT_X)/100.0f;
      tmp.data[2]=1;
      wld=cPos*tmp;
      cTarget.data[6]=wld.data[0];
      cTarget.data[7]=wld.data[1];
      pln=true;
    }
    if (jHUD_MAP_X<pix&&pix<jHUD_MAP_X+640&&jHUD_MAP_Y<piy&&piy<jHUD_MAP_Y+640) {
      cTarget.data[6]=(piy-jHUD_MAP_Y-320)*jMAP2GND;
      cTarget.data[7]=(pix-jHUD_MAP_X-320)*jMAP2GND;
      cTarget.data[8]=1;
      pln=true;
    }
    if (pln) {
      cRouting(cROUTEHOME);
      cPlanning();
    }
  }
}


// contributes to front view
// line of straight ahead, pan, tilt
void cMapPlot(void) {
  int c1;
  SDL_Rect mySDL_Rect;
  Uint32 myUint32=SDL_MapRGBA(&jSDL_PixelFormat,jGRAY,jGRAY,jGRAY, 64); // grey
  for (c1=-4;c1<=4;c1++) {
    mySDL_Rect.x=jMAP_X+(Sint16)(c1*jGND2MAP);
    mySDL_Rect.y=0;
    mySDL_Rect.w=1;
    mySDL_Rect.h=640;
    if (0<mySDL_Rect.x&&mySDL_Rect.x<640)
      SDL_FillRect(cMap,&mySDL_Rect,myUint32);
    mySDL_Rect.x=0;
    mySDL_Rect.y=jMAP_Y+(Sint16)(c1*jGND2MAP);
    mySDL_Rect.w=640;
    mySDL_Rect.h=1;
    if (0<mySDL_Rect.y&&mySDL_Rect.y<640)
      SDL_FillRect(cMap,&mySDL_Rect,myUint32);
  }
}

void cHUD(void) {
  int c1,c2,c3;  
  Uint32 col;
  SDL_Rect mySDL_Rect;
  matrix<float> pnt;
  sprintf(jChar,"l%6.3f r%6.3f",jTic[jTOC_TIME_LOCALIZE]*0.001f,jTic[jTOC_TIME_ROUTING]*0.001f);
  jDrawString(screen,jChar,238,0);
  
  jDraw(jEVERYWHERE,&cDock.data[6],0.04f,SDL_MapRGBA(&jSDL_PixelFormat,192,000,128,255),&filledEllipseRGBA);
  jDrawFrame(jEVERYWHERE,cDock,SDL_MapRGB(&jSDL_PixelFormat,192,000,128));
  
  jDraw(jEVERYWHERE,&cDrop.data[6],0.04f,SDL_MapRGBA(&jSDL_PixelFormat,128,192,000,255),&filledEllipseRGBA);
  jDrawFrame(jEVERYWHERE,cDrop,SDL_MapRGB(&jSDL_PixelFormat,128,192,000));
  
  jDraw(jEVERYWHERE,&cTurn.data[6],0.04f,SDL_MapRGBA(&jSDL_PixelFormat,000,192,128,255),&filledEllipseRGBA);
  jDrawFrame(jEVERYWHERE,cTurn,SDL_MapRGB(&jSDL_PixelFormat,000,192,128));
  
  matrix<float> grp(3,4,"ones");
  grp.data[ 0]=-.125;
  grp.data[ 1]= .405;
  grp.data[ 3]=-.075;
  grp.data[ 4]= .255;
  grp.data[ 6]= .075;
  grp.data[ 7]= .255;
  grp.data[ 9]= .125;
  grp.data[10]= .405;
  grp=cPos*grp;
  jDraw(jIN_FRONT,grp,SDL_MapRGB(&jSDL_PixelFormat,128,128,128),&filledPolygonRGBA);
  jDraw(jIN_MAP  ,grp,SDL_MapRGB(&jSDL_PixelFormat,128,128,128),&polygonRGBA);
  // INSTANTANEOUS
  // robots frame
  jDraw(jIN_MAP,&cPos.data[6],jROBOT_RADIUS_M,SDL_MapRGBA(&jSDL_PixelFormat,128,128,128,255),&ellipseRGBA);  
  lineRGBA(cMap,
    (int)(jMAP_X+ cPos.data[7]                  *jGND2MAP),
    (int)(jMAP_Y+ cPos.data[6]                  *jGND2MAP),
    (int)(jMAP_X+(cPos.data[7]+cCompass.data[1]*0.2f)*jGND2MAP),
    (int)(jMAP_Y+(cPos.data[6]+cCompass.data[0]*0.2f)*jGND2MAP), 64, 64,255,255);
  jDrawFrame(jIN_MAP,cPos,SDL_MapRGB(&jSDL_PixelFormat,255,255,255));  
  // camera field of view
  col=SDL_MapRGB(&jSDL_PixelFormat, 64, 64,255);
  jDraw(jEVERYWHERE,cPos*jSight[0],col,&polygonRGBA);
  jDraw(jEVERYWHERE,cPos*jSight[1],col,&polygonRGBA);
  
  // target frame  
  jDraw(jIN_FRONT|jIN_MAP,&cTarget.data[6],.10f,SDL_MapRGBA(&jSDL_PixelFormat,  0,128,128,255),&ellipseRGBA);  
  jDrawFrame(jEVERYWHERE,cTarget,SDL_MapRGB(&jSDL_PixelFormat,  0,255,255));  
  jDraw(jIN_MAP,&cTarget.data[6],"t");
  
  matrix<float> loc(3,1);
  loc.data[0]=cTarget.data[6];
  loc.data[1]=cTarget.data[7];
  loc.data[2]=1;
  loc=cInv*loc;
  loc.data[2]=0;
  float ang=atan2(-loc.data[0],loc.data[1]);      
  sprintf(jChar,"%5.2f\t$%6.1f",ang,cPlanDist);  
  jDraw(jIN_FRONT,&cTarget.data[6],jChar);
  
  if (jTog[jTOG_IN_HAZARD])   // marks the circle redish if in hazard and plots the degree
    jDrawFrame(jIN_FRONT|jIN_MAP,cPos*jHazard,SDL_MapRGB(&jSDL_PixelFormat,255,000,000));    
  
  // laser range finder coordinates
  pnt=cPos*jLaser;
  col=SDL_MapRGB(&jSDL_PixelFormat,192, 64, 00); // red
  for(c1=0;c1<jLaserSize;c1++)
    jDrawPoint(jEVERYWHERE,&pnt.data[c1*3],1,col);
  // stones perceived right now that are reachable
	pnt=cPos*jReachable;
  col=SDL_MapRGB(&jSDL_PixelFormat,235,155, 84); // yellow
	for (c1=0;c1<pnt.size[1];c1++)
  	jDraw((jIN_CAMERA<<jPROFILE_CAM)|jIN_FRONT|jIN_MAP,&pnt.data[c1*3],0.09f,col,&ellipseRGBA);  	  
  // PERMANENT
  int pin;
	matrix<float> pos(3,1);
  pos.data[2]=1;
  col=SDL_MapRGB(&jSDL_PixelFormat,000,000,255);  
  while (cPlan.token(pin)) {
    pos.data[0]=((pin/640)-jMAP_X)*jMAP2GND;
    pos.data[1]=((pin%640)-jMAP_X)*jMAP2GND;
    jDrawPoint(jEVERYWHERE,pos.data,1,col);
  }
  
  mySDL_Rect.x=0;
  mySDL_Rect.y=jBAR_STONES_Y+11+5;
  mySDL_Rect.h=1;
  mySDL_Rect.w=jFRONT_W;
  SDL_FillRect(screen,&mySDL_Rect,SDL_MapRGBA(screen->format,jGRAY,jGRAY,jGRAY,255));
  
  // BEGIN: draw stones of worldmap
  col=SDL_MapRGB(&jSDL_PixelFormat,192,255,000);
  for (c1=0;c1<cStone.size[1];c1++)
    jDraw(jIN_MAP,&cStone.data[c1*3],.06f,SDL_MapRGBA(&jSDL_PixelFormat,255,128,000,255),&ellipseRGBA);
  sprintf(jChar,"# m%i p%i r%i c%i",cStone.size[1],jStone.size[1],jReachable.size[1],jTic[jTOC_STONES_SINCE_VENTURE]);
  jDrawString(screen,jChar,0,jBAR_STONES_Y);
  // END: draw stones of worldmap
  
  mySDL_Rect.x=jHUD_MAP_X;
	mySDL_Rect.y=jHUD_MAP_Y;
	switch (cDisplay) {
  	case 0:
  	  jDrawString(cMap,"density",0,0);
  	  SDL_BlitSurface(cDensityDraw,NULL,screen,&mySDL_Rect);
  	  break;
  	case 1:
  	  jDrawString(cMap,"routing",0,0);
  	  SDL_BlitSurface(cRouteDraw  ,NULL,screen,&mySDL_Rect);
  	  break;  	  
  	case 2:
  	  jDrawString(cMap,"profile",0,0);
  	  SDL_BlitSurface(cDensityDraw,NULL,screen,&mySDL_Rect); 
      SDL_BlitSurface(cProfileDraw,NULL,screen,&mySDL_Rect);
      break;
    case 3:
      jDrawString(cMap,"targets",0,0);
      SDL_BlitSurface(cDensityDraw,NULL,screen,&mySDL_Rect);
      SDL_BlitSurface(cProfileDraw,NULL,screen,&mySDL_Rect); 
      SDL_BlitSurface(cProfileGone,NULL,screen,&mySDL_Rect);
      break;
  }
}
