// code by jph

// jDrawString draws myString to mySDL_Surface at (x,y)
// tab character breaks line
void jDrawString(SDL_Surface* mySDL_Surface,char* myString,int x,int y) {
  if (mySDL_Surface==NULL)
    return;
  int c1=0;
  SDL_Rect src,dst;
  src.x=0;
  src.y=0;
  src.w=7;
  src.h=11;
  dst.x=x;
  dst.y=y;
  while (myString[c1]) {
    if (myString[c1]=='\t') {      
      dst.x=x;
      dst.y+=11;
    } else {
      src.x=(myString[c1]-32)*7;
      SDL_BlitSurface(jFont,&src,mySDL_Surface,&dst);    
      dst.x+=7;
    }
    c1++;
  }
}

// jDrawString draws myString to mySDL_Surface at (x,y)
// tab character breaks line
void jDrawString(SDL_Surface* mySDL_Surface,SDL_Surface* myFont,char* myString,int x,int y) {
  if (mySDL_Surface==NULL||myFont==NULL)
    return;
  int c1=0;
  SDL_Rect src,dst;
  src.x=0;
  src.y=0;
  src.w=7;
  src.h=11;
  dst.x=x;
  dst.y=y;
  while (myString[c1]) {
    if (myString[c1]=='\t') {      
      dst.x=x;
      dst.y+=11;
    } else {
      src.x=(myString[c1]-32)*7;
      SDL_BlitSurface(myFont,&src,mySDL_Surface,&dst);    
      dst.x+=7;
    }
    c1++;
  }
}


// draws rectangle around wld with WIDth and COLor
// takes world coordinates
// SAFE
void jDrawPoint(int mySDL_Surfaces,float* wld,int wid,Uint32 col) {  
  int c1,pin,wid2=wid/2;
  int pix,piy;
  SDL_Rect mySDL_Rect; mySDL_Rect.w=wid; mySDL_Rect.h=wid;
  matrix<float> map(3,1);
  map.data[0]=wld[0]; map.data[1]=wld[1]; map.data[2]=1;
  matrix<float> loc=cInv*map;
  for (c1=0;c1<2;c1++)
    if (camera[c1]&&(mySDL_Surfaces&(jIN_CAMERA<<c1))) {
      pin=jGnd2cam(c1,loc.data);
      if (0<pin) {
        pix=(pin%320)-wid2;
        piy=(pin/320)-wid2;
        if (0<pix&&pix<320&&0<piy&&piy<240) {
          mySDL_Rect.x=(Sint16)pix;
          mySDL_Rect.y=(Sint16)piy;
          SDL_FillRect(camera[c1],&mySDL_Rect,col);
        }
      }
    }
  if (mySDL_Surfaces&jIN_FRONT) {
    pix=jFRONT_X+(int)(loc.data[1]*jGND2FRONT)-wid2;
    piy=jFRONT_Y+(int)(loc.data[0]*jGND2FRONT)-wid2;
    if (0<pix&&pix<jFRONT_W&&0<piy&&piy<jFRONT_H) {
      mySDL_Rect.x=(Sint16)pix;
      mySDL_Rect.y=(Sint16)piy;
      SDL_FillRect(jFront,&mySDL_Rect,col);	  
    }
  }
  if (mySDL_Surfaces&jIN_MAP) {
    pix=jMAP_X+(int)(map.data[1]*jGND2MAP)-wid2;
    piy=jMAP_Y+(int)(map.data[0]*jGND2MAP)-wid2;
    if (0<pix&&pix<640&&0<piy&&piy<640) {
      mySDL_Rect.x=(Sint16)pix;
      mySDL_Rect.y=(Sint16)piy;
      SDL_FillRect(cMap,&mySDL_Rect,col);
    }
  }
}

// draws frame around wld with WIDth and COLor
// takes world coordinates
// SAFE
void jDrawFrame(int mySDL_Surfaces,matrix<float> frm,Uint32 col) {
  int c1;
  int pin,pix,piy;
  int wid=3,wid2=1;
  SDL_Rect mySDL_Rect; mySDL_Rect.w=wid; mySDL_Rect.h=wid;
  matrix<float> loc=cInv*frm;
  float tmp[2];
  for (c1=0;c1<2;c1++)
    if (camera[c1]&&(mySDL_Surfaces&(jIN_CAMERA<<c1))) {
      pin=jGnd2cam(c1,&loc.data[6]);
      if (0<pin) {
        pix=pin%320;
        piy=pin/320;
        mySDL_Rect.x=(Uint16)pix-wid2;
        mySDL_Rect.y=(Uint16)piy-wid2;
        SDL_FillRect(camera[c1],&mySDL_Rect,col);
        tmp[0]=loc.data[6]+loc.data[0]*jVECTOR_M;
        tmp[1]=loc.data[7]+loc.data[1]*jVECTOR_M;
        pin=jGnd2cam(c1,tmp);
        if (0<pin)
          lineRGBA(camera[c1],pix,piy,pin%320,pin/320,255,  0,255,255);
        tmp[0]=loc.data[6]+loc.data[3]*jVECTOR_M;
        tmp[1]=loc.data[7]+loc.data[4]*jVECTOR_M;
        pin=jGnd2cam(c1,tmp);
        if (0<pin)
          lineRGBA(camera[c1],pix,piy,pin%320,pin/320,  0,255,255,255);
      }
    }
  if (mySDL_Surfaces&jIN_FRONT) {
    pix=(int)(jFRONT_X+loc.data[7]*jGND2FRONT);
    piy=(int)(jFRONT_Y+loc.data[6]*jGND2FRONT);
    if (0<pix&&pix<jFRONT_W&&0<piy&&piy<jFRONT_H) {
      mySDL_Rect.x=(Uint16)pix-wid2;
      mySDL_Rect.y=(Uint16)piy-wid2;
	    SDL_FillRect(jFront,&mySDL_Rect,col);
      lineRGBA(jFront,pix,piy,pix+(int)(loc.data[1]*jVECTOR_CM),piy+(int)(loc.data[0]*jVECTOR_CM),255,  0,255,255);
      lineRGBA(jFront,pix,piy,pix+(int)(loc.data[4]*jVECTOR_CM),piy+(int)(loc.data[3]*jVECTOR_CM),  0,255,255,255);
    }
  }
  if (mySDL_Surfaces&jIN_MAP) {
    pix=(int)(jMAP_X+frm.data[7]*jGND2MAP);
    piy=(int)(jMAP_Y+frm.data[6]*jGND2MAP);
    if (0<pix&&pix<jMAP_W&&0<piy&&piy<jMAP_H) {
      mySDL_Rect.x=(Uint16)pix-wid2;
      mySDL_Rect.y=(Uint16)piy-wid2;
	    SDL_FillRect(cMap,&mySDL_Rect,col);
      lineRGBA(cMap,pix,piy,pix+(int)(frm.data[1]*jVECTOR_CM),piy+(int)(frm.data[0]*jVECTOR_CM),255,  0,255,255);
      lineRGBA(cMap,pix,piy,pix+(int)(frm.data[4]*jVECTOR_CM),piy+(int)(frm.data[3]*jVECTOR_CM),  0,255,255,255);
    }
  }
}

// this jDraw serves functions &polygonRGBA and &filledPolygonRGBA
// only occurrence of function pointers in j2b2 operating system
// SAFE
void jDraw(int mySDL_Surfaces,const matrix<float> &map,Uint32 col,int (*func)(SDL_Surface*,const Sint16*,const Sint16*,int,Uint8,Uint8,Uint8,Uint8)) {
  int c1,c2;  
  Uint8 r,g,b;
  SDL_GetRGB(col,&jSDL_PixelFormat,&r,&g,&b);
  Sint16 pix[map.size[1]];
  Sint16 piy[map.size[1]];
  bool drw;  
  if (mySDL_Surfaces&(jIN_FRONT)) {    
    matrix<float> loc=cInv*map;
    drw=true;
    for (c1=0;c1<loc.size[1];c1++) {      
      pix[c1]=(Sint16)(jFRONT_X+loc.data[c1*3+1]*100);
      piy[c1]=(Sint16)(jFRONT_Y+loc.data[c1*3+0]*100);
      drw&=0<pix[c1]&&pix[c1]<jFRONT_W&&0<piy[c1]&&piy[c1]<jFRONT_H;
    }  
    if (drw) {
      //if (mySDL_Surfaces&jIN_FRONT)
      //  func(jFront       ,pix,piy,loc.size[1],r,g,b,255);  
    }
  }  
  if (mySDL_Surfaces&(jIN_MAP|jIN_DENSITYSTUB|jIN_PROFILEMASK)) {
    drw=true;
    for (c1=0;c1<map.size[1];c1++) {
      pix[c1]=(Sint16)(jMAP_X+map.data[c1*3+1]*jGND2MAP);
      piy[c1]=(Sint16)(jMAP_Y+map.data[c1*3+0]*jGND2MAP);
      drw&=0<pix[c1]&&pix[c1]<jMAP_W&&0<piy[c1]&&piy[c1]<jMAP_H;
    }
    if (drw) {
      //if (mySDL_Surfaces&jIN_MAP)
      //  func(cMap         ,pix,piy,map.size[1],r,g,b,255);
      if (mySDL_Surfaces&jIN_DENSITYSTUB)
        func(cDensityStub ,pix,piy,map.size[1],r,g,b,255);    
      if (mySDL_Surfaces&jIN_PROFILEMASK)
        func(jProfileMask ,pix,piy,map.size[1],r,g,b,255);    
    }
  }
}

// this jDraw serves functions &polygonRGBA and &filledPolygonRGBA
// only occurrence of function pointers in j2b2 operating system
// SAFE
void jDrawLocal(int mySDL_Surfaces,const matrix<float> &loc,Uint32 col,int (*func)(SDL_Surface*,const Sint16*,const Sint16*,int,Uint8,Uint8,Uint8,Uint8)) {
  int c1,c2;  
  Uint8 r,g,b;
  SDL_GetRGB(col,&jSDL_PixelFormat,&r,&g,&b);
  Sint16 pix[loc.size[1]];
  Sint16 piy[loc.size[1]];
  bool drw;
  if (mySDL_Surfaces&(jIN_FRONT|jIN_PROFILEMASK)) {
    drw=true;
    for (c1=0;c1<loc.size[1];c1++) {
      pix[c1]=(Sint16)(jFRONT_X+loc.data[c1*3+1]*100);
      piy[c1]=(Sint16)(jFRONT_Y+loc.data[c1*3+0]*100);
      drw&=0<pix[c1]&&pix[c1]<jFRONT_W&&0<piy[c1]&&piy[c1]<jFRONT_H;
    }
    if (drw) {
      if (mySDL_Surfaces&jIN_FRONT)
        func(jFront,pix,piy,loc.size[1],r,g,b,255);  
      if (mySDL_Surfaces&jIN_PROFILEMASK)
        func(jProfileMask,pix,piy,loc.size[1],r,g,b,255);  
    }
  }
}


// jDraw serves
// &ellipseRGBA
// &filledEllipseRGBA
void jDraw(int mySDL_Surfaces,float* wld,float rad,Uint32 col,int (*func)(SDL_Surface*,Sint16,Sint16,Sint16,Sint16,Uint8,Uint8,Uint8,Uint8)) {
  Uint8 r,g,b;
  int c1;
  int pin,pix,piy;
  SDL_GetRGB(col,&jSDL_PixelFormat,&r,&g,&b);  
  matrix<float> map(3,1);
  map.data[0]=wld[0];
  map.data[1]=wld[1];
  map.data[2]=1.0f;
  matrix<float> loc=cInv*map;    
  for (c1=0;c1<2;c1++)
    if (camera[c1]&&(mySDL_Surfaces&(jIN_CAMERA<<c1))) {
      pin=jGnd2cam(c1,loc.data);
      if (0<pin) {
        pix=pin%320;
        piy=pin/320;
        func(camera[c1],pix,piy,(int)(rad*100),(int)(rad*100),r,g,b,255);
      }
    }
  if (mySDL_Surfaces&jIN_FRONT) {
    pix=(int)(jFRONT_X+loc.data[1]*100);
    piy=(int)(jFRONT_Y+loc.data[0]*100);
    if (0<pix&&pix<jFRONT_W&&0<piy&&piy<jFRONT_H)
      func(jFront,pix,piy,(int)(rad*100),(int)(rad*100),r,g,b,255);
  }
  if (mySDL_Surfaces&(jIN_MAP|jIN_DENSITYSTUB|jIN_PROFILEGONE)) {
    pix=(int)(jMAP_X+map.data[1]*jGND2MAP);
    piy=(int)(jMAP_Y+map.data[0]*jGND2MAP);
    if (0<pix&&pix<jMAP_W&&0<piy&&piy<jMAP_H) {
      if (mySDL_Surfaces&jIN_MAP)
        func(cMap,pix,piy,(int)(rad*jGND2MAP),(int)(rad*jGND2MAP),r,g,b,255);
      if (mySDL_Surfaces&jIN_DENSITYSTUB)
        func(cDensityStub,pix,piy,(int)(rad*jGND2MAP),(int)(rad*jGND2MAP),r,g,b,255);
      if (mySDL_Surfaces&jIN_PROFILEGONE)
        func(cProfileGone,pix,piy,(int)(rad*jGND2MAP),(int)(rad*jGND2MAP),r,g,b,255);
    }
  }
}


// this jDraw writes the text directly to the coordinate systems
// SAFE
void jDraw(int mySDL_Surfaces,float* wld,char* myString) {
  int c1,pin;
  int pix,piy;  
  matrix<float> map(3,1);
  map.data[0]=wld[0]; map.data[1]=wld[1]; map.data[2]=1;
  matrix<float> loc=cInv*map;
  for (c1=0;c1<2;c1++)
    if (camera[c1]&&(mySDL_Surfaces&(jIN_CAMERA<<c1))) {
      pin=jGnd2cam(c1,loc.data);
      if (0<pin)
        jDrawString(camera[c1],myString,pin%320,pin/320);      
    }
  if (mySDL_Surfaces&jIN_FRONT) {
    pix=jFRONT_X+(int)(loc.data[1]*jGND2FRONT);
    piy=jFRONT_Y+(int)(loc.data[0]*jGND2FRONT);
    if (0<pix&&pix<jFRONT_W&&0<piy&&piy<jFRONT_H)
      jDrawString(jFront,myString,pix,piy);
  }
  if (mySDL_Surfaces&jIN_MAP) {
    pix=jMAP_X+(int)(map.data[1]*jGND2MAP);
    piy=jMAP_Y+(int)(map.data[0]*jGND2MAP);
    if (0<pix&&pix<jMAP_W&&0<piy&&piy<jMAP_H)
      jDrawString(cMap,myString,pix,piy);
  }
}

// flush cameras, front, map onto screen
// record everything
void jDraw(void) {
  SDL_Rect mySDL_Rect;
  mySDL_Rect.x=jHUD_CAMERAL_X;
  mySDL_Rect.y=jHUD_CAMERAL_Y;
  if (camera[0])
    SDL_BlitSurface(camera[0],NULL,screen,&mySDL_Rect);  
  mySDL_Rect.x=jHUD_CAMERAR_X;
  mySDL_Rect.y=jHUD_CAMERAR_Y;
  if (camera[1])
    SDL_BlitSurface(camera[1],NULL,screen,&mySDL_Rect);
  
  mySDL_Rect.x=jHUD_FRONT_X;
	mySDL_Rect.y=jHUD_FRONT_Y;
	SDL_BlitSurface(jFront,NULL,screen,&mySDL_Rect);    
	SDL_FillRect(jFront,NULL,SDL_MapRGBA(jFront->format,000,000,000,000));

  mySDL_Rect.x=jHUD_MAP_X;
	mySDL_Rect.y=jHUD_MAP_Y;
	SDL_BlitSurface(cMap,NULL,screen,&mySDL_Rect);
	SDL_FillRect(cMap,NULL,SDL_MapRGBA(cMap->format,000,000,000,000));
		
	if (jTic[jTOC_NEXT_SCREENSHOT]<jTic[jTOC_LAST_SENSORS]&&
	                  jVel.norm(2)<jSTILLSTAND
	  ) {
  	sprintf(jChar,"out/test%i.bmp",jTic[jTOC_LAST_SENSORS]);
  	SDL_SaveBMP(screen,jChar);
  	if (jTog[jTOG_TRANSMIT_TO_GROUND1]) {
    	SDL_LockSurface(screen);
    	ctrl.GIMnet_SendMessage("j2b2ctrl_ground1",screen->pixels,jSCREEN_W*jSCREEN_H*screen->format->BytesPerPixel);
    	SDL_UnlockSurface(screen);
  	}
  	jTic[jTOC_NEXT_SCREENSHOT]=jTic[jTOC_LAST_SENSORS]+5000;
    cDisplay++; cDisplay%=cDISPLAY;
	}
}

