// code by jph

SDL_Surface* jFont;             // bitmap with characters for drawing
SDL_Surface* jFond;             // bitmap with characters for drawing

SDL_Surface* jBarR;
SDL_Surface* jBarG;
SDL_Surface* jBarB;
SDL_Surface* jBarV;
SDL_Surface* jBarY;
SDL_Surface* jBarT;
SDL_Surface* jBarO;

// BEGIN: macros
#define jIN_CAMERA          1 // use as jIN_CAMERA<<0   or   jIN_CAMERA<<1
#define jIN_FRONT           4
#define jIN_MAP             8
#define jEVERYWHERE        15 // cameras, front, map
#define jIN_DENSITY        16
#define jIN_DENSITYSTUB    32
#define jIN_PROFILEMASK    64
#define jIN_PROFILEGONE   128


#define jHUD_CAMERAL_X    380 // 320x240
#define jHUD_CAMERAL_Y      0
#define jHUD_CAMERAR_X    700
#define jHUD_CAMERAR_Y      0
#define jFRONT_W          380
#define jFRONT_H          640
#define jHUD_FRONT_X        0 // 480x640
#define jHUD_FRONT_Y      240
#define jMAP_W            640
#define jMAP_H            640
#define jHUD_MAP_X        380
#define jHUD_MAP_Y        240

#define jGRAY             192
                          
#define jBAR_W            100
#define jBAR_H             11
#define jBAR_BOOST_X      126
#define jBAR_BOOST_Y       11
#define jBAR_ACCEL_X      238
#define jBAR_ACCEL_Y       11
#define jBAR_YELLOW_X     126
#define jBAR_YELLOW_Y      22
#define jBAR_RELLOW_X     238
#define jBAR_RELLOW_Y      22
#define jBAR_AVOID_X      126
#define jBAR_AVOID_Y       66

#define jBAR_STONES_Y      77

#define jBAR_HAZARD0_X    126
#define jBAR_HAZARD0_Y     55
#define jBAR_HAZARD1_X    238
#define jBAR_HAZARD1_Y     55

#define pBAR_GAIN_INT_X   126
#define pBAR_GAIN_INT_Y    99
#define pBAR_GAIN_POS_X   238
#define pBAR_GAIN_POS_Y    99

#define pBAR_MASTER_X     126
#define pBAR_MASTER_Y     168
// END: macros

// BEGIN: coordinate system parameters
#define jFRONT_X           30
#define jFRONT_Y          320    
#define jMAP_X            320
#define jMAP_Y            320
#define jGND2FRONT        100
#define jFRONT2GND          0.01f
#define jVECTOR_M           0.25f
#define jVECTOR_CM          25
#define jGND2MAP          66.6f
#define jMAP2GND          0.015015f
// END: coordinate system parameters


// jDrawString draws myString to mySDL_Surface at (x,y)
// tab character breaks line
void jDrawString(SDL_Surface* mySDL_Surface,char* myString,int x,int y);
void jDrawString(SDL_Surface* mySDL_Surface,SDL_Surface* myFont,char* myString,int x,int y);

// draws rectangle around wld with WIDth and COLor
// takes world coordinates
void jDrawPoint(int mySDL_Surfaces,float* wld,int wid,Uint32 col);

// draws frame around wld with WIDth and COLor
// takes world coordinates
void jDrawFrame(int mySDL_Surfaces,matrix<float> frm,Uint32 col);

// this jDraw serves functions &polygonRGBA and &filledPolygonRGBA
void jDraw(int mySDL_Surfaces,const matrix<float> &map,Uint32 col,int (*func)(SDL_Surface*,const Sint16*,const Sint16*,int,Uint8,Uint8,Uint8,Uint8));
void jDrawLocal(int mySDL_Surfaces,const matrix<float> &loc,Uint32 col,int (*func)(SDL_Surface*,const Sint16*,const Sint16*,int,Uint8,Uint8,Uint8,Uint8));

// this jDraw serves functions &ellipseRGBA and &filledEllipseRGBA
void jDraw(int mySDL_Surfaces,float* wld,float rad,Uint32 col,int (*func)(SDL_Surface*,Sint16,Sint16,Sint16,Sint16,Uint8,Uint8,Uint8,Uint8));

// this jDraw writes the text directly to the coordinate systems
void jDraw(int mySDL_Surfaces,float* wld,char* myString);
